# Functions used by all tests.
#
# Copyright (C) 2011  Simon Ruderich
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


cleanup() {
    rm -f \
        certificate-localhost-proxy.pem certificate-localhost-server.pem \
        proxy-ca-key.pem proxy-ca.pem proxy-invalid.pem proxy-key.pem
}
abort() {
    echo abort
    pkill -n gnutls-serv
    pkill -n tlsproxy
    exit 1
}
server() {
    gnutls-serv --http --port 4712 "$@" >/dev/null 2>/dev/null &
}
client() {
    ./client ./proxy-ca.pem "$@" > tmp 2>&1
}

test_proxy_failure() {
    grep 'proxy failure' tmp >/dev/null || abort
    grep 'response: HTTP/1.0 503 Forwarding failure' tmp >/dev/null \
        || abort
}
test_proxy_successful() {
    grep 'response: HTTP/1.0 200 Connection established' tmp >/dev/null \
        || abort
}
test_invalid_certificate() {
    grep 'certificate invalid' tmp >/dev/null || abort
}
test_no_invalid_certificate() {
    grep 'certificate invalid' tmp >/dev/null && abort
}
